﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WCS.Entity.Protocol
{
    /// <summary>
    /// 站台状态
    /// </summary>
    public interface IStationStatus : IDATA
    {
        /// <summary>
        /// 标记
        /// </summary>
        StatusFlags Flags { get; set; }
    }

    [Flags]
    public enum StatusFlags : Int32
    {
        总故障 = 1 << 0,
        急停故障 = 1 << 1,
        超时故障 = 1 << 2,
        驱动故障 = 1 << 3,
        空气开关故障 = 1 << 4,
        传感器异常故障 = 1 << 5,
        超边故障 = 1 << 6,
        无Ready信号 = 1 << 7,
        超时故障2 = 1 << 8,
        驱动故障2 = 1 << 9,
        空气开关故障2 = 1 << 10,
        前极限故障 = 1 << 11,
        后极限故障 = 1 << 12,
        无Ready信号2 = 1 << 13,
        上极限故障 = 1 << 14,
        下极限故障 = 1 << 15,
        备用 = 1 << 16,
        自动 = 1 << 17,
        选中 = 1 << 18,
        任务有货 = 1 << 19,
        光电有货 = 1 << 20,
        运行状态位 = 1 << 21,
        正转 = 1 << 22,
        反转 = 1 << 23,
        上升_右转_伸出 = 1 << 24,
        下降_左转_缩回 = 1 << 25,
        高位 = 1 << 26,
        中位 = 1 << 27,
        低位 = 1 << 28,
        前位 = 1 << 29,
        后位 = 1 << 30,
    }

}
